#!/usr/bin/env node

import Create from './cli/Create'
import exec from 'exec'
import fse from 'fs-extra'
import program from 'commander'
import pkg from '../package'

program
  .version(pkg.version)
  .option('-p, --port <port>', 'Port on which to listen to (defaults to 8000)', parseInt)
  .option('-i, --interactive', 'open in browser')
  .option('-pn, --pname <pname>', 'pm2 server name')
  .parse(process.argv)

var userArgs = process.argv.slice(2)
var create = new Create()
var port = program.port
var interactive = program.interactive
var pm2Name = program.pname

if(typeof userArgs[0] !== 'undefined' && userArgs[0] !== null){

	switch(userArgs[0]){
		case 'create':
			if(userArgs[1]) create.init(userArgs[1])
			else console.error("Error: no project path specified")
		break
		case 'serve':
			var dir = process.cwd();
			var command = 'ROOT=' + dir + ' npm run start'
			if (interactive) command = 'OPENURL=1 ' + command
			if(port) command = 'PORT=' + port + ' ' + command
			process.chdir(__dirname + '/../')
			console.log('website stared : ' + dir + (port ? ' on port :' + port : ''))
			exec(command, function (err, out, code) {
				if (err instanceof Error) throw err
			  process.stderr.write(err)
			  process.stdout.write(out)
			  process.exit(code)
			})
		break
		case 'servepm2':
			var dir = process.cwd();
			var command = "ROOT=" + dir + " pm2 start ./dist/server/index.js --node-args='--harmony'";
			if (interactive) command = 'OPENURL=1 ' + command
			if(port) command = 'PORT=' + port + ' ' + command
			if(pm2Name) command = command + ` --name="${pm2Name}"`
			process.chdir(__dirname + '/../')
			console.log('pm2 command : ' + command)
			exec(command, function (err, out, code) {
				if (err instanceof Error) throw err
			  process.stderr.write(err)
			  process.stdout.write(out)
			  process.exit(code)
			})
		break
		case 'servenodemon':
			var dir = process.cwd();
			var command = 'ROOT=' + dir + ' npm run startdev'
			if (interactive) command = 'OPENURL=1 ' + command
			if(port) command = 'PORT=' + port + ' ' + command
			process.chdir(__dirname + '/../')
			console.log('website stared : ' + dir + (port ? ' on port :' + port : ''))
			exec(command, function (err, out, code) {
				if (err instanceof Error) throw err
			  process.stderr.write(err)
			  process.stdout.write(out)
			  process.exit(code)
			})
		break
		case 'stop':
			exec('pm2 delete all', function (err, out, code) {
				if (err instanceof Error) throw err
			  process.stderr.write(err)
			  process.stdout.write(out)
			  process.exit(code)
			})
		break
		default:
			console.log("Help: use `create` or `serve` command")
		break
	}

}
else{
	console.log("Help: use `create` or `serve` command")
}
